#!/usr/bin/env ts-node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable camelcase */
var tstest_1 = require("tstest");
var vm_1 = __importDefault(require("vm"));
var mustache_1 = __importDefault(require("mustache"));
var partial_lookup_1 = require("../partial-lookup");
var sidecar_metadata_fixture_1 = require("../../../tests/fixtures/sidecar-metadata.fixture");
var mod_1 = require("../../wrappers/mod");
(0, tstest_1.test)('render rpc-exports()', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var SIDECAR_METADATA, view, template, code, context;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                SIDECAR_METADATA = (0, sidecar_metadata_fixture_1.getSidecarMetadataFixture)();
                view = (0, mod_1.wrapView)(SIDECAR_METADATA);
                return [4 /*yield*/, (0, partial_lookup_1.partialLookup)('rpc-exports.mustache')
                    // console.log(template)
                ];
            case 1:
                template = _a.sent();
                code = mustache_1.default.render(template, view);
                context = {
                    __sidecar__agentMethod_Function_wrapper: function () { },
                    __sidecar__anotherCall_Function_wrapper: function () { },
                    __sidecar__pointerMethod_Function_wrapper: function () { },
                    __sidecar__testMethod_Function_wrapper: function () { },
                    __sidecar__voidMethod_Function_wrapper: function () { },
                    rpc: {
                        exports: {},
                    },
                };
                vm_1.default.createContext(context); // Contextify the object.
                vm_1.default.runInContext(code, context);
                t.true('testMethod' in context.rpc.exports, 'should export testMethod');
                t.true('pointerMethod' in context.rpc.exports, 'should export pointerMethod');
                t.true('anotherCall' in context.rpc.exports, 'should export anotherCall');
                t.true('agentMethod' in context.rpc.exports, 'should export agentCall');
                /**
                 * Do not export Hook/Interceptor methods
                 */
                t.false('hookMethod' in context.rpc.exports, 'should not export hookMethod');
                return [2 /*return*/];
        }
    });
}); });
//# sourceMappingURL=rpc-exports.spec.js.map