"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Call = void 0;
var config_1 = require("../../config");
var metadata_call_1 = require("./metadata-call");
var update_rpc_descriptor_1 = require("./update-rpc-descriptor");
function Call(functionTarget) {
    config_1.log.verbose('Sidecar', '@Call(%s)', typeof functionTarget === 'string' ? functionTarget
        : typeof functionTarget === 'number' ? "0x" + functionTarget.toString(16)
            : JSON.stringify(functionTarget));
    return function callMethodDecorator(target, propertyKey, descriptor) {
        config_1.log.verbose('Sidecar', '@Call(%s) callMethodDecorator(%s, %s, descriptor)', typeof functionTarget === 'object' ? JSON.stringify(functionTarget)
            : typeof functionTarget === 'number' ? '0x' + functionTarget.toString(16)
                : functionTarget, target.constructor.name, propertyKey);
        (0, metadata_call_1.updateMetadataCall)(target, propertyKey, functionTarget);
        var rpcDescriptor = (0, update_rpc_descriptor_1.updateRpcDescriptor)(target, propertyKey, descriptor);
        return rpcDescriptor;
    };
}
exports.Call = Call;
//# sourceMappingURL=call.js.map