"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || from);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateRpcDescriptor = void 0;
var config_1 = require("../../config");
var ret_1 = require("../../ret");
var constants_1 = require("./constants");
function updateRpcDescriptor(target, propertyKey, descriptor) {
    config_1.log.verbose('Sidecar', 'updateRpcDescriptor(%s, %s, descriptor)', target.constructor.name, propertyKey);
    // console.log('value:', descriptor.value)
    var ret = descriptor.value();
    if (!(ret instanceof Promise)) {
        var e = new Error("The \"" + target.constructor.name + "." + propertyKey + "\" method return a non-promise: it must return the Ret() to make Sidecar @Call happy.");
        console.error(e.stack);
        throw e;
    }
    else {
        ret.then(function (result) {
            /**
             * FIXME: Huan(202006)
             *  check Ret value and deal the error more gentle
             */
            if (result !== ret_1.RET_SYMBOL) {
                var e = new Error("The \"" + target.constructor.name + "." + propertyKey + "\" method must return the Ret() to make Sidecar @Call happy.");
                console.error(e.stack);
                throw e;
            }
            return result;
        }).catch(function (e) {
            target[constants_1.DEBUG_CALL_RET_ERROR] = e;
            console.error(e);
        });
    }
    function proxyMethod() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                // // https://github.com/huan/clone-class/blob/master/src/instance-to-class.ts
                // const klass = (this.constructor.name as any as typeof SidecarBody)
                // console.log('target:', target)
                // console.log('target.name:', target.name)
                // console.log('target.constructor.name:', target.constructor.name)
                config_1.log.verbose(target.constructor.name + "<Sidecar>", propertyKey + "(%s)", args.join(', '));
                if (!this.script) {
                    config_1.log.warn("Sidecar<" + target.constructor.name + ">", '%s(%s) updateRpcDescriptor() > proxyMethod() > "this.script" is undefined.', propertyKey, args.join(', '));
                    this.emit('error', new Error('proxyMethod() found this.script is undefined'));
                    return [2 /*return*/];
                }
                return [2 /*return*/, (_a = this.script.exports)[propertyKey].apply(_a, __spreadArray([], __read(args), false))];
            });
        });
    }
    /**
     * Update the method
     */
    descriptor.value = proxyMethod;
    return descriptor;
}
exports.updateRpcDescriptor = updateRpcDescriptor;
//# sourceMappingURL=update-rpc-descriptor.js.map