#!/usr/bin/env ts-node
"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var tstest_1 = require("tstest");
var stream_1 = require("stream");
var ret_1 = require("../../ret");
var constants_1 = require("./constants");
var update_rpc_descriptor_1 = require("./update-rpc-descriptor");
(0, tstest_1.test)('update & get call target metadata', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var AFTER_VALUE, Test, test, descriptor, beforeValue, rpcDescriptor, rpcValue, ret;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                AFTER_VALUE = 42;
                Test = /** @class */ (function () {
                    function Test() {
                        this.script = {
                            exports: {
                                testMethod: function () { return AFTER_VALUE; },
                            },
                        };
                    }
                    Test.prototype.testMethod = function () { return (0, ret_1.Ret)(); };
                    return Test;
                }());
                test = new Test();
                descriptor = Reflect.getOwnPropertyDescriptor(Test.prototype, 'testMethod');
                return [4 /*yield*/, (descriptor === null || descriptor === void 0 ? void 0 : descriptor.value())];
            case 1:
                beforeValue = _a.sent();
                t.equal(beforeValue, ret_1.RET_SYMBOL, 'should get RET_SYMBOL before update rpc method');
                rpcDescriptor = (0, update_rpc_descriptor_1.updateRpcDescriptor)(Test, 'testMethod', descriptor);
                return [4 /*yield*/, rpcDescriptor.value.bind(test)()];
            case 2:
                rpcValue = _a.sent();
                t.equal(rpcValue, AFTER_VALUE, 'should get AFTER_VALUE from rpcValue');
                Object.defineProperty(Test.prototype, 'testMethod', rpcDescriptor);
                return [4 /*yield*/, test.testMethod()];
            case 3:
                ret = _a.sent();
                t.equal(ret, AFTER_VALUE, 'should get a updated method return value');
                return [4 /*yield*/, new Promise(setImmediate)];
            case 4:
                _a.sent();
                t.false(Test[constants_1.DEBUG_CALL_RET_ERROR], 'should not trigger error if the method returns "Ret()"');
                return [2 /*return*/];
        }
    });
}); });
(0, tstest_1.test)('method to be proxyed must retur "Ret()"', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var RET_VALUE, Test, descriptor, beforeValue;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                RET_VALUE = 42;
                Test = /** @class */ (function (_super) {
                    __extends(Test, _super);
                    function Test() {
                        return _super !== null && _super.apply(this, arguments) || this;
                    }
                    Test.prototype.method = function () {
                        return Promise.resolve(RET_VALUE);
                    };
                    return Test;
                }(stream_1.EventEmitter));
                descriptor = Reflect.getOwnPropertyDescriptor(Test.prototype, 'method');
                return [4 /*yield*/, (descriptor === null || descriptor === void 0 ? void 0 : descriptor.value())];
            case 1:
                beforeValue = _a.sent();
                t.equal(beforeValue, RET_VALUE, 'should get ret value from the descriptor');
                (0, update_rpc_descriptor_1.updateRpcDescriptor)(Test, 'method', descriptor);
                return [4 /*yield*/, new Promise(setImmediate)];
            case 2:
                _a.sent();
                t.true(Test[constants_1.DEBUG_CALL_RET_ERROR], 'should trigger error if the method does not return "Ret()" (We can safely ignore the Error message above this test)');
                return [2 /*return*/];
        }
    });
}); });
//# sourceMappingURL=update-rpc-descriptor.spec.js.map