"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.guardRetType = void 0;
var config_1 = require("../../config");
var type_guard_1 = require("../../type-guard");
/**
 * Verify the TypeScript ret type is matching the NativeType from `RetType`
 */
function guardRetType(target, propertyKey, nativeType, pointerTypeList) {
    var _a, _b;
    var designRetType = Reflect.getMetadata('design:returntype', target, propertyKey);
    config_1.log.verbose('Sidecar', 'guardRetType(%s.%s) designType/nativeType/pointerTypeList: %s/%s/[%s]', target.constructor.name, propertyKey, (_a = designRetType === null || designRetType === void 0 ? void 0 : designRetType.name) !== null && _a !== void 0 ? _a : 'void', nativeType, pointerTypeList.join(','));
    try {
        (0, type_guard_1.guardNativeType)(nativeType)(designRetType);
        if (nativeType === 'pointer') {
            (0, type_guard_1.guardPointerType)(pointerTypeList)(designRetType);
        }
    }
    catch (e) {
        config_1.log.error('Sidecar', 'guardRetType() %s', e && e.message);
        throw new Error([
            "The " + target.constructor.name + "." + String(propertyKey) + "()",
            "decorated by \"@RetType(" + nativeType + ", ...)\"",
            "does match the design return type \"" + ((_b = designRetType === null || designRetType === void 0 ? void 0 : designRetType.name) !== null && _b !== void 0 ? _b : 'void') + "\"",
        ].join('\n'));
    }
}
exports.guardRetType = guardRetType;
//# sourceMappingURL=guard-ret-type.js.map