"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isSidecarTargetSpawn = exports.isSidecarTargetProcess = exports.normalizeSidecarTarget = void 0;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var config_1 = require("../../config");
var sidecarTargetObjProcess = function (target) { return ({
    target: target,
    type: 'process',
}); };
var sidecarTargetObjSpawn = function (target) { return ({
    target: target,
    type: 'spawn',
}); };
var normalizeSidecarTarget = function (target) {
    if (typeof target === 'string' || typeof target === 'number') {
        return sidecarTargetObjProcess(target);
    }
    else if (Array.isArray(target)) {
        var command = path_1.default.resolve(process.cwd(), target[0]);
        if (fs_1.default.existsSync(command)) {
            config_1.log.verbose('Sidecar', 'normalizeSidecarTarget() spawn command found: "%s"', command);
            target[0] = command;
        }
        else {
            config_1.log.warn('Sidecar', 'normalizeSidecarTarget() spawn command not found: "%s"', command);
        }
        return sidecarTargetObjSpawn(target);
    }
    else {
        return target;
    }
};
exports.normalizeSidecarTarget = normalizeSidecarTarget;
var isSidecarTargetProcess = function (target) { return typeof target === 'object' && !Array.isArray(target) && target.type === 'process'; };
exports.isSidecarTargetProcess = isSidecarTargetProcess;
var isSidecarTargetSpawn = function (target) { return typeof target === 'object' && !Array.isArray(target) && target.type === 'spawn'; };
exports.isSidecarTargetSpawn = isSidecarTargetSpawn;
//# sourceMappingURL=target.js.map