#!/usr/bin/env ts-node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var tstest_1 = require("tstest");
var target_1 = require("./target");
(0, tstest_1.test)('normalizeSidecarTarget() processTarget: number', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var TARGET, EXPECTED, actual;
    return __generator(this, function (_a) {
        TARGET = 0x1234;
        EXPECTED = {
            target: TARGET,
            type: 'process',
        };
        actual = (0, target_1.normalizeSidecarTarget)(TARGET);
        t.deepEqual(actual, EXPECTED, 'should normalize number to process target');
        t.true((0, target_1.isSidecarTargetProcess)(actual), 'should be a process target');
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('normalizeSidecarTarget() processTarget: string', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var TARGET, EXPECTED, actual;
    return __generator(this, function (_a) {
        TARGET = 'namedTarget';
        EXPECTED = {
            target: TARGET,
            type: 'process',
        };
        actual = (0, target_1.normalizeSidecarTarget)(TARGET);
        t.deepEqual(actual, EXPECTED, 'should normalize string to process target');
        t.true((0, target_1.isSidecarTargetProcess)(actual), 'should be a process target');
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('normalizeSidecarTarget() spawnTarget: []', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var TARGET, EXPECTED, actual;
    return __generator(this, function (_a) {
        TARGET = [
            'command',
            [
                'arg1',
                'arg2',
            ],
        ];
        EXPECTED = {
            target: TARGET,
            type: 'spawn',
        };
        actual = (0, target_1.normalizeSidecarTarget)(TARGET);
        t.deepEqual(actual, EXPECTED, 'should normalize array to spawn target');
        t.true((0, target_1.isSidecarTargetSpawn)(actual), 'should be a spawn target');
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('normalizeSidecarTarget() obj: {}', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var TARGET, actual;
    return __generator(this, function (_a) {
        TARGET = {
            target: [
                'command',
                ['arg1'],
            ],
            type: 'spawn',
        };
        actual = (0, target_1.normalizeSidecarTarget)(TARGET);
        t.deepEqual(actual, TARGET, 'should normalize obj unchanged');
        t.true((0, target_1.isSidecarTargetSpawn)(actual), 'should be a spawn target');
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('normalizeSidecarTarget() undefined', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var TARGET, actual;
    return __generator(this, function (_a) {
        TARGET = undefined;
        actual = (0, target_1.normalizeSidecarTarget)(TARGET);
        t.deepEqual(actual, undefined, 'should normalize undefined to undefined');
        t.false((0, target_1.isSidecarTargetSpawn)(actual), 'should not be a spawn target');
        t.false((0, target_1.isSidecarTargetProcess)(actual), 'should not be a process target');
        return [2 /*return*/];
    });
}); });
//# sourceMappingURL=target.spec.js.map