"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sourceHandler = void 0;
/* eslint-disable sort-keys */
var vm_1 = __importDefault(require("vm"));
var path_1 = __importDefault(require("path"));
var slash_1 = __importDefault(require("slash"));
var config_1 = require("../config");
var metadata_sidecar_1 = require("../decorators/sidecar/metadata-sidecar");
var build_agent_source_1 = require("../agent/build-agent-source");
var extract_class_names_1 = require("./extract-class-names");
var sourceHandler = function (_a) {
    var file = _a.file, name = _a.name;
    return __awaiter(void 0, void 0, void 0, function () {
        var classNameList, context, code, script, generatedCode;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    file = (0, slash_1.default)(file);
                    config_1.log.verbose('sidecar-dump <source>', 'file<%s>, name<%s>', file, name || '');
                    if (!!name) return [3 /*break*/, 2];
                    return [4 /*yield*/, (0, extract_class_names_1.extractClassNameList)(file)];
                case 1:
                    classNameList = _b.sent();
                    if (classNameList.length === 0) {
                        throw new Error("There's no @Sidecar decorated class name found in file " + file);
                    }
                    else if (classNameList.length > 1) {
                        console.error("Found multiple @Sidecar decorated classes in " + file + ", please specify the class name by --name:\n");
                        console.error(classNameList.map(function (x) { return '  ' + x; }).join('\n'));
                        /**
                         * return empty string when error
                         */
                        return [2 /*return*/, ''];
                    }
                    name = classNameList[0];
                    config_1.log.silly('sidecar-dump <source>', 'detected class name: "%s"', name);
                    _b.label = 2;
                case 2:
                    context = {
                        buildAgentSource: build_agent_source_1.buildAgentSource,
                        getMetadataSidecar: metadata_sidecar_1.getMetadataSidecar,
                        require: require,
                        __filename: file,
                        __dirname: path_1.default.dirname(require.resolve(file)),
                    };
                    code = [
                        '(async () => {',
                        [
                            "const { " + name + " } = require('" + file + "')",
                            "const metadata = getMetadataSidecar(" + name + ")",
                            'const output = await buildAgentSource(metadata)',
                            'return output',
                        ].join('\n'),
                        '})()',
                    ].join('\n');
                    config_1.log.silly('sidecar-dump <source>', code);
                    script = new vm_1.default.Script(code);
                    return [4 /*yield*/, script.runInNewContext(context)];
                case 3:
                    generatedCode = _b.sent();
                    return [2 /*return*/, generatedCode];
            }
        });
    });
};
exports.sourceHandler = sourceHandler;
//# sourceMappingURL=source-handler.js.map