#!/usr/bin/env ts-node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var tstest_1 = require("tstest");
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var string_similarity_1 = __importDefault(require("string-similarity"));
var source_handler_1 = require("./source-handler");
(0, tstest_1.test)('sourceHandler()', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var CLASS_FILE, FIXTURE_FILE, normalize, FIXTURE, source, normalizedSource, normalizedFixture, similarity, THRESHOLD, ok;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                CLASS_FILE = path_1.default.join(__dirname, '..', '..', 'examples', 'chatbox-sidecar.ts');
                FIXTURE_FILE = path_1.default.join(__dirname, '..', '..', 'tests', 'fixtures', 'sidecar-dump.source.chatbox-sidecar.js.fixture');
                normalize = function (text) { return text
                    /**
                     * Strip file path line for CI under Linux & Windows
                     */
                    .replace(/^.*chatbox.*$/gm, '')
                    .replace(/[^\S\r\n]+/g, ' ')
                    .replace(/^ +$/gm, '') // remove spaces in empty line
                    .replace(/\r/g, '') // Windows will add \r, which need to be removed for comparing
                    .replace(/\n+$/s, ''); } // strip all the ending newlines
                ;
                return [4 /*yield*/, fs_1.default
                        .readFileSync(FIXTURE_FILE)
                        .toString()];
            case 1:
                FIXTURE = _a.sent();
                return [4 /*yield*/, (0, source_handler_1.sourceHandler)({ file: CLASS_FILE })
                    /**
                     * Generate the testing fixture file, Huan(202107)
                     *
                     *  When we have updated the examples/chatbox-sidecar.ts file,
                     *  we need to update the `tests/fixtures/sidecar-dump.source.chatbox-sidecar.js.fixture`
                     *  so that the unit testing can be match the updated frida agent source code.
                     */
                    // fs.writeFileSync('t.js', source)
                    /**
                     * We remove all spaces in the file so that the comparision will ignore all spaces
                     */
                ];
            case 2:
                source = _a.sent();
                normalizedSource = normalize(source);
                normalizedFixture = normalize(FIXTURE);
                similarity = string_similarity_1.default.compareTwoStrings(normalizedFixture, normalizedSource);
                void normalizedSource;
                void normalizedFixture;
                THRESHOLD = 0.95;
                ok = similarity > THRESHOLD;
                // console.log('similarity:', similarity)
                t.true(ok, "should get the source from ts file with similarity(" + Math.floor(similarity * 100) + "%) > " + THRESHOLD * 100 + "%");
                return [2 /*return*/];
        }
    });
}); });
//# sourceMappingURL=source-handler.spec.js.map