#!/usr/bin/env ts-node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var tstest_1 = require("tstest");
var tsd_1 = require("tsd");
var function_target_1 = require("./function-target");
(0, tstest_1.test)('PointerType typing', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var type;
    return __generator(this, function (_a) {
        type = {};
        (0, tsd_1.expectType)(type);
        t.pass('PointerType should be typing right');
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('NativeType typing', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var type;
    return __generator(this, function (_a) {
        type = '';
        (0, tsd_1.expectType)(type);
        t.pass('NativeType should be typing right');
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('TargetType typing', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var type;
    return __generator(this, function (_a) {
        type = '';
        (0, tsd_1.expectType)(type);
        t.pass('TargetType should be typing right');
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('ScriptMessageHandler typing', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var handler;
    return __generator(this, function (_a) {
        handler = {};
        (0, tsd_1.expectType)(handler);
        t.pass('ScriptMessageHandler should be typing right');
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('normalizeFunctionTarget()', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var TEST_LIST, result, expected;
    return __generator(this, function (_a) {
        TEST_LIST = [
            [
                'stringTarget',
                { funcName: 'stringTarget', type: 'agent' },
            ],
            [
                0x42,
                { address: '0x42', moduleName: null, type: 'address' },
            ],
        ];
        result = TEST_LIST.map(function (pair) { return pair[0]; }).map(function_target_1.normalizeFunctionTarget);
        expected = TEST_LIST.map(function (pair) { return pair[1]; });
        t.deepEqual(result, expected, 'should normalize function target as expected');
        return [2 /*return*/];
    });
}); });
//# sourceMappingURL=frida.spec.js.map