"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeFunctionTarget = exports.exportTarget = exports.agentTarget = exports.addressTarget = void 0;
var addressTarget = function (address, moduleName) {
    if (moduleName === void 0) { moduleName = null; }
    return ({
        address: "0x" + Number(address).toString(16),
        moduleName: moduleName,
        type: 'address',
    });
};
exports.addressTarget = addressTarget;
var agentTarget = function (funcName) { return ({
    funcName: funcName,
    type: 'agent',
}); };
exports.agentTarget = agentTarget;
var exportTarget = function (exportName, moduleName) {
    if (moduleName === void 0) { moduleName = null; }
    return ({
        exportName: exportName,
        moduleName: moduleName,
        type: 'export',
    });
};
exports.exportTarget = exportTarget;
/**
 * Convert the `string` and `number` type target to Obj
 */
function normalizeFunctionTarget(target) {
    if (typeof target === 'number') {
        return addressTarget(target);
    }
    else if (typeof target === 'string') {
        return agentTarget(target);
    }
    return target;
}
exports.normalizeFunctionTarget = normalizeFunctionTarget;
//# sourceMappingURL=function-target.js.map