"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exportTarget = exports.agentTarget = exports.addressTarget = exports.SidecarBody = exports.Sidecar = exports.RetType = exports.Ret = exports.ParamType = exports.Hook = exports.Call = exports.detach = exports.attach = exports.debug = exports.VERSION = void 0;
/**
 *   Sidecar - https://github.com/huan/sidecar
 *
 *   @copyright 2021 Huan LI (李卓桓) <https://github.com/huan>
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 */
var version_1 = require("./version");
Object.defineProperty(exports, "VERSION", { enumerable: true, get: function () { return version_1.VERSION; } });
var ret_1 = require("./ret");
Object.defineProperty(exports, "Ret", { enumerable: true, get: function () { return ret_1.Ret; } });
var mod_1 = require("./sidecar-body/mod");
Object.defineProperty(exports, "SidecarBody", { enumerable: true, get: function () { return mod_1.SidecarBody; } });
Object.defineProperty(exports, "attach", { enumerable: true, get: function () { return mod_1.attach; } });
Object.defineProperty(exports, "detach", { enumerable: true, get: function () { return mod_1.detach; } });
var constants_1 = require("./sidecar-body/constants");
/**
 * Decorators
 */
var mod_2 = require("./decorators/call/mod");
Object.defineProperty(exports, "Call", { enumerable: true, get: function () { return mod_2.Call; } });
var mod_3 = require("./decorators/hook/mod");
Object.defineProperty(exports, "Hook", { enumerable: true, get: function () { return mod_3.Hook; } });
var mod_4 = require("./decorators/param-type/mod");
Object.defineProperty(exports, "ParamType", { enumerable: true, get: function () { return mod_4.ParamType; } });
var mod_5 = require("./decorators/ret-type/mod");
Object.defineProperty(exports, "RetType", { enumerable: true, get: function () { return mod_5.RetType; } });
var mod_6 = require("./decorators/sidecar/mod");
Object.defineProperty(exports, "Sidecar", { enumerable: true, get: function () { return mod_6.Sidecar; } });
/**
 * Target helpers
 */
var function_target_1 = require("./function-target");
Object.defineProperty(exports, "addressTarget", { enumerable: true, get: function () { return function_target_1.addressTarget; } });
Object.defineProperty(exports, "agentTarget", { enumerable: true, get: function () { return function_target_1.agentTarget; } });
Object.defineProperty(exports, "exportTarget", { enumerable: true, get: function () { return function_target_1.exportTarget; } });
var debug = {
    ATTACH_SYMBOL: constants_1.ATTACH_SYMBOL,
    DETACH_SYMBOL: constants_1.DETACH_SYMBOL,
    HOOK_EVENT_HANDLER: constants_1.HOOK_EVENT_HANDLER,
    INIT_SYMBOL: constants_1.INIT_SYMBOL,
    LOG_EVENT_HANDLER: constants_1.LOG_EVENT_HANDLER,
    SCRIPT_DESTROYED_HANDLER_SYMBOL: constants_1.SCRIPT_DESTROYED_HANDLER_SYMBOL,
    SCRIPT_MESSAGRE_HANDLER_SYMBOL: constants_1.SCRIPT_MESSAGRE_HANDLER_SYMBOL,
};
exports.debug = debug;
//# sourceMappingURL=mod.js.map