#!/usr/bin/env ts-node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var tstest_1 = require("tstest");
var type_guard_1 = require("./type-guard");
(0, tstest_1.test)('guardNativeType()', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var DESIGN_NATIVE_PAIR_LIST, _loop_1, DESIGN_NATIVE_PAIR_LIST_1, DESIGN_NATIVE_PAIR_LIST_1_1, _a, designType, nativeType, shouldMatch;
    var e_1, _b;
    return __generator(this, function (_c) {
        DESIGN_NATIVE_PAIR_LIST = [
            [String, 'pointer', true],
            [Boolean, 'bool', true],
            [Number, 'int', true],
            [undefined, 'void', true],
            [undefined, 'pointer', true],
            // Huan(202107): Number might be a point to the number.
            // Need to check the PointerType to make sure it is a number.
            [Number, 'pointer', true],
            [String, 'char', false],
            [undefined, 'char', false],
            [Boolean, 'int', false],
        ];
        _loop_1 = function (designType, nativeType, shouldMatch) {
            if (shouldMatch) {
                t.doesNotThrow(function () { return (0, type_guard_1.guardNativeType)(nativeType)(designType); }, [
                    'should not throw when match:',
                    "\"" + (designType === null || designType === void 0 ? void 0 : designType.name) + "\" <> \"" + nativeType + "\"",
                ].join(' '));
            }
            else {
                t.throws(function () { return (0, type_guard_1.guardNativeType)(nativeType)(designType); }, [
                    'should throw when does not match:',
                    "\"" + (designType === null || designType === void 0 ? void 0 : designType.name) + "\" <> \"" + nativeType + "\"",
                ].join(' '));
            }
        };
        try {
            for (DESIGN_NATIVE_PAIR_LIST_1 = __values(DESIGN_NATIVE_PAIR_LIST), DESIGN_NATIVE_PAIR_LIST_1_1 = DESIGN_NATIVE_PAIR_LIST_1.next(); !DESIGN_NATIVE_PAIR_LIST_1_1.done; DESIGN_NATIVE_PAIR_LIST_1_1 = DESIGN_NATIVE_PAIR_LIST_1.next()) {
                _a = __read(DESIGN_NATIVE_PAIR_LIST_1_1.value, 3), designType = _a[0], nativeType = _a[1], shouldMatch = _a[2];
                _loop_1(designType, nativeType, shouldMatch);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (DESIGN_NATIVE_PAIR_LIST_1_1 && !DESIGN_NATIVE_PAIR_LIST_1_1.done && (_b = DESIGN_NATIVE_PAIR_LIST_1.return)) _b.call(DESIGN_NATIVE_PAIR_LIST_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return [2 /*return*/];
    });
}); });
(0, tstest_1.test)('guardPointerType()', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var DESIGN_POINTER_PAIR_LIST, _loop_2, DESIGN_POINTER_PAIR_LIST_1, DESIGN_POINTER_PAIR_LIST_1_1, _a, designType, pointerType, shouldMatch;
    var e_2, _b;
    return __generator(this, function (_c) {
        DESIGN_POINTER_PAIR_LIST = [
            [String, 'Utf8String', true],
            [Boolean, 'Int', true],
            [Number, 'Long', true],
            /**
             * Huan(202107): it is no sense for `void` has a pointer type:
             *  we just do not check it for convenience. (by setting match to `true`)
             */
            [undefined, 'U8', true],
            [Number, 'Pointer', false],
            [String, 'U32', false],
        ];
        _loop_2 = function (designType, pointerType, shouldMatch) {
            if (shouldMatch) {
                t.doesNotThrow(function () { return (0, type_guard_1.guardPointerType)([pointerType])(designType); }, [
                    'should not throw when match:',
                    "\"" + (designType === null || designType === void 0 ? void 0 : designType.name) + "\" <> \"" + pointerType + "\"",
                ].join(' '));
            }
            else {
                t.throws(function () { return (0, type_guard_1.guardPointerType)([pointerType])(designType); }, [
                    'should throw when does not match:',
                    "\"" + (designType === null || designType === void 0 ? void 0 : designType.name) + "\" <> \"" + pointerType + "\"",
                ].join(' '));
            }
        };
        try {
            for (DESIGN_POINTER_PAIR_LIST_1 = __values(DESIGN_POINTER_PAIR_LIST), DESIGN_POINTER_PAIR_LIST_1_1 = DESIGN_POINTER_PAIR_LIST_1.next(); !DESIGN_POINTER_PAIR_LIST_1_1.done; DESIGN_POINTER_PAIR_LIST_1_1 = DESIGN_POINTER_PAIR_LIST_1.next()) {
                _a = __read(DESIGN_POINTER_PAIR_LIST_1_1.value, 3), designType = _a[0], pointerType = _a[1], shouldMatch = _a[2];
                _loop_2(designType, pointerType, shouldMatch);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (DESIGN_POINTER_PAIR_LIST_1_1 && !DESIGN_POINTER_PAIR_LIST_1_1.done && (_b = DESIGN_POINTER_PAIR_LIST_1.return)) _b.call(DESIGN_POINTER_PAIR_LIST_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return [2 /*return*/];
    });
}); });
//# sourceMappingURL=type-guard.spec.js.map