"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || from);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.declareNativeArgs = void 0;
var name_helpers_1 = require("./name-helpers");
function declareNativeArgs() {
    var e_1, _a;
    var name = this.name;
    var paramTypeList = this.paramTypeList;
    /**
     * There's no any parameters needed
     */
    if (!Array.isArray(paramTypeList) || paramTypeList.length === 0) {
        return '';
    }
    var declareStatementList = [];
    try {
        for (var _b = __values(paramTypeList.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), argIdx = _d[0], paramTypeChain = _d[1];
            /**
             * 0. Loop for all parameter args...
             */
            var _e = __read(paramTypeChain), nativeType = _e[0], pointerTypeList = _e.slice(1);
            // console.log(argIdx, nativeType, pointerTypeList)
            var statementChain = [];
            /**
             * 1. arg is non-pointer
             */
            if (nativeType !== 'pointer') {
                statementChain.push("// non-pointer type for arg[" + argIdx + "]: " + nativeType, "const " + (0, name_helpers_1.nativeArgName)(name, argIdx) + " = " + (0, name_helpers_1.argName)(argIdx));
                declareStatementList.push(statementChain.join('\n'));
                continue;
            }
            if (pointerTypeList.length === 0) {
                /**
                 * 2. arg is a pointer
                 */
                statementChain.push("// pointer type for arg[" + argIdx + "] -> " + pointerTypeList.join(' -> '), 
                // Number() is to convert the `null` to number
                "const " + (0, name_helpers_1.nativeArgName)(name, argIdx) + " = ptr(Number(" + (0, name_helpers_1.argName)(argIdx) + "))");
            }
            else { // pointerTypeList.length > 0
                /**
                 * 3. arg is a pointer to pointer...
                 */
                statementChain.push.apply(// pointerTypeList.length > 0
                statementChain, __spreadArray([], __read(generatePointerTypeStatementChain(name, argIdx, pointerTypeList)), false));
            }
            declareStatementList.push(statementChain.join('\n'));
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return declareStatementList.join('\n\n');
}
exports.declareNativeArgs = declareNativeArgs;
function generatePointerTypeStatementChain(name, argIdx, pointerTypeList) {
    var e_2, _a;
    var statementChain = [];
    /**
     * Current arg is a native pointer
     */
    statementChain.push("// pointer type for arg[" + argIdx + "] -> " + pointerTypeList.join(' -> '), 
    // FIXME: Huan(202106) how to get the size? (1024)
    "const " + (0, name_helpers_1.nativeArgName)(name, argIdx) + " = Memory.alloc(1024 /*Process.pointerSize*/)");
    var lastVarName = (0, name_helpers_1.nativeArgName)(name, argIdx);
    try {
        for (var _b = __values(pointerTypeList.entries()), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), typeIdx = _d[0], pointerType = _d[1];
            if (pointerType === 'Pointer') {
                statementChain.push("const " + (0, name_helpers_1.bufName)(name, argIdx, typeIdx) + " = Memory.alloc(Process.pointerSize)", lastVarName + ".writePointer(" + (0, name_helpers_1.bufName)(name, argIdx, typeIdx) + ")");
                lastVarName = (0, name_helpers_1.bufName)(name, argIdx, typeIdx);
            }
            else {
                /**
                 * Best Practices: String allocation (UTF-8/UTF-16/ANSI)
                 *  https://frida.re/docs/best-practices/
                 *
                 * Huan(202106) FIXME: alloc memory for string before assign to native argumenments
                 */
                statementChain.push(lastVarName + ".write" + pointerType + "(" + (0, name_helpers_1.argName)(argIdx) + ")");
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_2) throw e_2.error; }
    }
    return statementChain;
}
//# sourceMappingURL=declare-native-args.js.map