#!/usr/bin/env ts-node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || from);
};
Object.defineProperty(exports, "__esModule", { value: true });
var tstest_1 = require("tstest");
var sidecar_metadata_fixture_1 = require("../../tests/fixtures/sidecar-metadata.fixture");
var js_args_1 = require("./js-args");
(0, tstest_1.test)('jsArgs()', function (t) { return __awaiter(void 0, void 0, void 0, function () {
    var SIDECAR_METADATA, nativeFunctionList, interceptorFunctionList, EXPECTED_ARGS_LIST, result;
    return __generator(this, function (_a) {
        SIDECAR_METADATA = (0, sidecar_metadata_fixture_1.getSidecarMetadataFixture)();
        nativeFunctionList = SIDECAR_METADATA.nativeFunctionList;
        interceptorFunctionList = SIDECAR_METADATA.interceptorList;
        EXPECTED_ARGS_LIST = [
            '[ args[0].readInt(), args[1].readPointer().readUtf8String() ]',
            '[ args[0].readUtf8String(), args[1] ]',
            '[ args[0] ]',
            '[  ]',
            '[  ]',
            '[ args[0], args[1].readUtf8String() ]',
        ];
        result = __spreadArray(__spreadArray([], __read(nativeFunctionList), false), __read(interceptorFunctionList), false).map(function (x) { return Object.values(x); })
            .flat()
            .map(function (x) { return js_args_1.jsArgs.call(x); });
        t.deepEqual(result, EXPECTED_ARGS_LIST, 'should wrap the args correct');
        return [2 /*return*/];
    });
}); });
//# sourceMappingURL=js-args.spec.js.map