"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.jsRet = void 0;
var config_1 = require("../config");
function jsRet() {
    var e_1, _a;
    var typeChain = this.retType;
    if (!typeChain) {
        // throw new Error('no .retType found in SidecarMetadataFunctionDescription context!')
        /**
         * Huan(202108): No type chain means we have not specified `@RetType`
         *  return raw data
         */
        return 'ret';
    }
    var _b = __read(typeChain), nativeType = _b[0], pointerTypeList = _b.slice(1);
    // console.log(nativeType, pointerTypeList)
    var resultChain = [];
    if (nativeType === 'pointer') {
        /**
         * Pointer native type mapping/chaining
         */
        if (pointerTypeList.length > 0) {
            resultChain.push('ret.readPointer()');
            try {
                for (var pointerTypeList_1 = __values(pointerTypeList), pointerTypeList_1_1 = pointerTypeList_1.next(); !pointerTypeList_1_1.done; pointerTypeList_1_1 = pointerTypeList_1.next()) {
                    var pointerType = pointerTypeList_1_1.value;
                    resultChain.push(".read" + pointerType + "()");
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (pointerTypeList_1_1 && !pointerTypeList_1_1.done && (_a = pointerTypeList_1.return)) _a.call(pointerTypeList_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        else {
            /**
             * Raw pointer
             */
            resultChain.push('ret');
        }
    }
    else {
        /**
         * Non-pointer native type mapping
         */
        switch (nativeType) {
            case 'bool':
                config_1.log.silly('Sidecar', 'wrappers/js-ret NativeType(bool) for ret');
                resultChain.push('Boolean(ret)');
                break;
            case 'void':
                config_1.log.silly('Sidecar', 'wrappers/js-ret NativeType(void) for ret');
                resultChain.push('undefined /* void */');
                break;
            default: // all number types
                config_1.log.silly('Sidecar', 'wrappers/js-ret NativeType(number<%s>) for ret', nativeType);
                resultChain.push('Number(ret)');
                break;
        }
    }
    return resultChain.join('');
}
exports.jsRet = jsRet;
//# sourceMappingURL=js-ret.js.map